/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.portletcontainer.plugins.pc;


/**
 * Created by The eXo Platform SARL
 * Author : Roman Pedchenko
 *          roman.pedchenko@exoplatform.com.ua
 */

public class Constants {
  public static final String renderString = "render";
  public static final String actionString = "action";
  public static final String eventString = "event";
  public static final String resourceString = "resource";
//  public static final String fragmentString = "fragment";
  public static final int renderInt = 0;
  public static final int actionInt = 1;
  public static final int eventInt = 2;
  public static final int resourceInt = 3;
//  public static final int fragmentInt = 4;

  public static String actionToString(int action) {
    switch (action) {
      case actionInt:
        return actionString;
      case eventInt:
        return eventString;
      case resourceInt:
        return resourceString;
//      case fragmentInt:
//        return fragmentString;
      default:
        return renderString;
    }
  }

  public static int actionToInt(String action) {
    if(action == null)
      return renderInt;
    if (action.equals(actionString))
      return actionInt;
    if (action.equals(eventString))
      return eventInt;
    if (action.equals(resourceString))
      return resourceInt;
//    if (action.equals(fragmentString))
//      return fragmentInt;
    return renderInt;
  }
}
