/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL    All rights reserved.       *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.plugins.pc.aop;

import org.apache.commons.logging.Log;
import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.services.log.LogService;
import org.exoplatform.container.component.ExecutionContext;
import org.exoplatform.container.component.ExecutionUnit ;
/*
 * @author: Benjamin Mestrallet
 * @author: Tuan Nguyen
 */
abstract public class BaseCommandUnit extends ExecutionUnit {
  protected Log log_ = 
    ((LogService)ExoContainerContext.getTopContainer().getComponentInstanceOfType(LogService.class)).
    getLog("org.exoplatform.services.portletcontainer");
  
  public Object execute(ExecutionContext context)  throws Throwable {
    if(context instanceof  RenderExecutionContext) {
      RenderExecutionContext rcontext  = (RenderExecutionContext) context ;
      return render(rcontext) ;
    } 
    if(context instanceof  EventExecutionContext) {
      EventExecutionContext econtext  = (EventExecutionContext) context ;
      return processEvent(econtext) ;
    } 
    if(context instanceof  ResourceExecutionContext) {
      ResourceExecutionContext rcontext  = (ResourceExecutionContext) context ;
      return serveResource(rcontext) ;
    }
//    if(context instanceof  FragmentExecutionContext) {
//      FragmentExecutionContext rcontext  = (FragmentExecutionContext) context ;
//      return serveFragment(rcontext) ;
//    } 
    ActionExecutionContext acontext  = (ActionExecutionContext) context ;
    return processAction(acontext) ;
  }
  
  protected Object render(RenderExecutionContext rcontext)  throws Throwable {
    return rcontext.executeNextUnit() ;
  }
  
  protected Object serveResource(ResourceExecutionContext rcontext)  throws Throwable {
    return rcontext.executeNextUnit() ;
  }
  
  protected Object processEvent(EventExecutionContext econtext)  throws Throwable  {
    return econtext.executeNextUnit() ;
  }
  
  protected Object processAction(ActionExecutionContext acontext)  throws Throwable  {
    return acontext.executeNextUnit() ;
  }
  
//  protected Object serveFragment(FragmentExecutionContext fcontext)  throws Throwable  {
//    return fcontext.executeNextUnit() ;
//  }
  
}