/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.       *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.plugins.pc.aop;

import org.exoplatform.services.portletcontainer.pci.RenderOutput;
import org.exoplatform.services.portletcontainer.pci.ResourceOutput;
//import org.exoplatform.services.portletcontainer.pci.FragmentOutput;

/*
 * @author: Benjamin Mestrallet
 * @author: Tuan Nguyen
 */
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.PortletResponseImp;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.RenderResponseImp;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.helpers.CustomResponseWrapper;

public class PortletContentCommand extends BaseCommandUnit {

  public Object render(RenderExecutionContext rcontext)  throws Throwable {
    log_.debug("--> render method, call content ");
    Object result =  rcontext.executeNextUnit() ;
    PortletResponseImp rimpl = (PortletResponseImp) rcontext.response_ ;
    CustomResponseWrapper responseWrapper = (CustomResponseWrapper)  rimpl.getResponse() ;
    responseWrapper.flushBuffer();
    RenderOutput routput = (RenderOutput) rimpl.getOutput() ;
    routput.setContent(responseWrapper.getPortletContent());
    routput.setCacheHit(false);
    RenderResponseImp renderRespImpl = (RenderResponseImp) rcontext.response_ ;
    routput.setNextPossiblePortletModes(renderRespImpl.getNextPossiblePortletModes());
    return result ;
  }

  public Object serveResource(ResourceExecutionContext rcontext)  throws Throwable {
    log_.debug("--> resource method, call content ");
    Object result =  rcontext.executeNextUnit() ;
    PortletResponseImp rimpl = (PortletResponseImp) rcontext.response_ ;
    CustomResponseWrapper responseWrapper = (CustomResponseWrapper)  rimpl.getResponse() ;
    responseWrapper.flushBuffer();
    ResourceOutput routput = (ResourceOutput) rimpl.getOutput() ;
    routput.setContent(responseWrapper.getPortletContent());
    return result ;
  }
  
//  public Object serveFragment(FragmentExecutionContext rcontext)  throws Throwable {
//    log_.debug("--> fragment method, call content ");
//    Object result =  rcontext.executeNextUnit() ;
//    PortletResponseImp rimpl = (PortletResponseImp) rcontext.response_ ;
//    CustomResponseWrapper responseWrapper = (CustomResponseWrapper)  rimpl.getResponse() ;
//    responseWrapper.flushBuffer();
//    FragmentOutput routput = (FragmentOutput) rimpl.getOutput() ;
//    routput.setContent(responseWrapper.getPortletContent());
//    return result ;
//  }
  
}