/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.       *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.plugins.pc.aop;

import javax.portlet.*;

import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.RenderRequestImp;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.ActionRequestImp;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.ResourceRequestImp;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.EventRequestImp;
//import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.FragmentRequestImp;


/*
 * @author: Benjamin Mestrallet
 * @author: Tuan Nguyen
 */

public class PortletMethodCommand extends BaseCommandUnit {

  protected Object render(RenderExecutionContext rcontext)  throws Throwable {
    RenderRequest request = rcontext.request_;
    RenderResponse response = rcontext.response_;
    request.setAttribute("javax.portlet.config",((RenderRequestImp)request).getPortletConfig());
    request.setAttribute("javax.portlet.request", request);
    request.setAttribute("javax.portlet.response", response);
    request.setAttribute(PortletRequest.LIFECYCLE_PHASE, PortletRequest.RENDER_PHASE);
    
    rcontext.portlet_.render(request, response) ;
    
    request.removeAttribute("javax.portlet.config");
    request.removeAttribute("javax.portlet.request");
    request.removeAttribute("javax.portlet.response"); 
    request.removeAttribute(PortletRequest.LIFECYCLE_PHASE); 
    return null ;
  }
  
  protected Object processAction(ActionExecutionContext acontext)  throws Throwable  {
    ActionRequest request = acontext.request_;
    ActionResponse response = acontext.response_;
    request.setAttribute("javax.portlet.config",((ActionRequestImp)request).getPortletConfig());
    request.setAttribute("javax.portlet.request", request);
    request.setAttribute("javax.portlet.response", response);
    request.setAttribute(PortletRequest.LIFECYCLE_PHASE, PortletRequest.ACTION_PHASE);
    
    acontext.portlet_.processAction(acontext.request_, acontext.response_) ;
    
    request.removeAttribute("javax.portlet.config");
    request.removeAttribute("javax.portlet.request");
    request.removeAttribute("javax.portlet.response"); 
    request.removeAttribute(PortletRequest.LIFECYCLE_PHASE); 
    return null ;
  }

  protected Object serveResource(ResourceExecutionContext rcontext)  throws Throwable {
    if (rcontext.portlet_ instanceof ResourceServingPortlet) {
      ResourceRequest request = rcontext.request_;
      ResourceResponse response = rcontext.response_;
      request.setAttribute("javax.portlet.config",((ResourceRequestImp)request).getPortletConfig());
      request.setAttribute("javax.portlet.request", request);
      request.setAttribute("javax.portlet.response", response);
      request.setAttribute(PortletRequest.LIFECYCLE_PHASE, PortletRequest.RESOURCE_SERVING_PHASE);
      
      ((ResourceServingPortlet) rcontext.portlet_).serveResource(rcontext.request_, rcontext.response_) ;     
      
      request.removeAttribute("javax.portlet.config");
      request.removeAttribute("javax.portlet.request");
      request.removeAttribute("javax.portlet.response"); 
      request.removeAttribute(PortletRequest.LIFECYCLE_PHASE); 
    }
    return null ;
  }
  
  protected Object processEvent(EventExecutionContext econtext)  throws Throwable  {
    if (econtext.portlet_ instanceof EventPortlet) {
      EventRequest request = econtext.request_;
      EventResponse response = econtext.response_;
      request.setAttribute("javax.portlet.config",((EventRequestImp)request).getPortletConfig());
      request.setAttribute("javax.portlet.request", request);
      request.setAttribute("javax.portlet.response", response);
      request.setAttribute(PortletRequest.LIFECYCLE_PHASE, PortletRequest.EVENT_PHASE);
      
      ((EventPortlet) econtext.portlet_).processEvent(econtext.request_, econtext.response_) ;
      
      request.removeAttribute("javax.portlet.config");
      request.removeAttribute("javax.portlet.request");
      request.removeAttribute("javax.portlet.response"); 
      request.removeAttribute(PortletRequest.LIFECYCLE_PHASE); 
    }
    return null ;
  }

//  protected Object serveFragment(FragmentExecutionContext fcontext)  throws Throwable  {
//    if (fcontext.portlet_ instanceof FragmentServingPortlet) {
//      FragmentRequest request = fcontext.request_;
//      FragmentResponse response = fcontext.response_;
//      request.setAttribute("javax.portlet.config",((FragmentRequestImp)request).getPortletConfig());
//      request.setAttribute("javax.portlet.request", request);
//      request.setAttribute("javax.portlet.response", response);
//      request.setAttribute(PortletRequest.LIFECYCLE_PHASE, PortletRequest.FRAGMENT_SERVING_PHASE);
//      
//      ((FragmentServingPortlet) fcontext.portlet_).serveFragment(fcontext.request_, fcontext.response_) ;
//      
//      request.removeAttribute("javax.portlet.config");
//      request.removeAttribute("javax.portlet.request");
//      request.removeAttribute("javax.portlet.response"); 
//      request.removeAttribute(PortletRequest.LIFECYCLE_PHASE); 
//    }
//    return null ;
//  }
  
}