/**
 * Copyright 2001-2003 The eXo Platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SARL
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: Jul 29, 2003
 * Time: 5:52:27 PM
 */
package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Enumeration;
import java.util.List;
import java.util.Locale;

import javax.portlet.CacheControl;
import javax.portlet.RenderResponse;
import javax.servlet.http.Cookie;

import org.apache.commons.lang.StringUtils;
import org.exoplatform.services.portletcontainer.pci.*;
import org.exoplatform.services.portletcontainer.pci.model.*;


public class RenderResponseImp extends MimeResponseImp implements RenderResponse {
  private Collection supportedContents_;
//  private String windowId_;
  private Input input_;
  private Portlet portletDatas_;
//  private boolean isCurrentlySecured_;
//  private String contentType_;
//  private boolean writerAlreadyCalled_;
//  private boolean outputStreamAlreadyCalled_;
//  private Enumeration supportedWindowState_;
//  private CacheControlImp cacheCtl;
  private Enumeration portletModes;

	public RenderResponseImp(ResponseContext resCtx) {
    super(resCtx);
//    this.windowId_ = resCtx.getWindowID();
    this.portletDatas_ = resCtx.getPortletDatas();
//    this.isCurrentlySecured_ = resCtx.isSecure();
    this.supportedContents_ = resCtx.getSupportedContents();
//    this.supportedWindowState_ = resCtx.getWindowStates();
    this.input_ = resCtx.getInput();
//    writerAlreadyCalled_ = false;
//    outputStreamAlreadyCalled_ = false;
//    cacheCtl = new CacheControlImp(this);
  }


  public void setTitle(String s) {
    ((RenderOutput) super.getOutput()).setTitle(s);
  }

  private boolean isContentTypeSupported(String contentTypeToTest){
    Collection c = getResponseContentTypes();
    for (Iterator iter = c.iterator(); iter.hasNext();) {
      String element = (String) iter.next();
      if(element.equals(contentTypeToTest)){
        return true;
      }
    }
    return false;
  }

  // TODO could be shared with PortletRequest.getResponseContentType()
  private Collection getResponseContentTypes() {
    Collection c = new ArrayList();
    c.add(getResponseContentType());
    for (Iterator iter = supportedContents_.iterator(); iter.hasNext();) {
      String element = (String) iter.next();
      List l = portletDatas_.getSupports();
      for (int i = 0; i < l.size(); i++) {
        Supports supportsType = (Supports) l.get(i);
        String mimeType = supportsType.getMimeType();
        if(element.equals(mimeType) && !element.equals(input_.getMarkup())){
          List portletModes = supportsType.getPortletMode();
          for (Iterator iter2 = portletModes.iterator(); iter2.hasNext();) {
            String portletMode = (String) iter2.next();
            if(portletMode.equals(input_.getPortletMode().toString())){
              c.add(mimeType);
              break;
            }
          }
        }
      }
    }
    return c;
  }

  private String getResponseContentType() {
    List l = portletDatas_.getSupports();
    for (int i = 0; i < l.size(); i++) {
      Supports supportsType = (Supports) l.get(i);
      String mimeType = supportsType.getMimeType();
      if (mimeType.equals(input_.getMarkup())){
        List portletModes = supportsType.getPortletMode();
        for (Iterator iter = portletModes.iterator(); iter.hasNext();) {
          String portletMode = (String) iter.next();
          if(portletMode.equals(input_.getPortletMode().toString())){
            return mimeType;
          }
        }
      }
    }
    return "text/html";
  }

  public void setNextPossiblePortletModes(Enumeration portletModes) {
    // TODO Zavizionov
    this.portletModes = portletModes;
  }
  
  public Enumeration getNextPossiblePortletModes() {
    // TODO Zavizionov
    return portletModes;
  }
  
}
