package javax.portlet;

import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Set;
import java.util.Map;

public interface PortletContext {

  public abstract String getServerInfo();

  public abstract PortletRequestDispatcher getRequestDispatcher(String s);

  public abstract PortletRequestDispatcher getNamedDispatcher(String s);

  public abstract InputStream getResourceAsStream(String s);

  public abstract int getMajorVersion();

  public abstract int getMinorVersion();

  public abstract String getMimeType(String s);

  public abstract String getRealPath(String s);

  public abstract Set getResourcePaths(String s);

  public abstract URL getResource(String s) throws MalformedURLException;

  public abstract Object getAttribute(String s);

  public abstract Enumeration getAttributeNames();

  public abstract String getInitParameter(String s);

  public abstract Enumeration getInitParameterNames();

  public abstract void log(String s);

  public abstract void log(String s, Throwable throwable);

  public abstract void removeAttribute(String s);

  public abstract void setAttribute(String s, Object obj);

  public abstract String getPortletContextName();
  
  public abstract Map getApplicationRuntimeOptions();
  
  public abstract Map getPortletRuntimeOptions();
  
}
