/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package javax.portlet.filter;

import java.io.IOException;
import java.util.Map;
import java.util.Enumeration;

import javax.portlet.ActionResponse;
import javax.portlet.PortletMode;
import javax.portlet.PortletModeException;
import javax.portlet.PortletURL;
import javax.portlet.ResourceURL;
import javax.portlet.WindowState;
import javax.portlet.WindowStateException;
import javax.xml.namespace.QName;
import javax.servlet.http.Cookie;

public class ActionResponseWrapper implements ActionResponse {

  ActionResponse response;
  
  private ActionResponseWrapper() {
  }
  
  public ActionResponseWrapper(ActionResponse response) {
    this.response = response;
  }

  public void sendRedirect(String location) throws IOException {
    response.sendRedirect(location);
  }

  public void setEvent(QName name, Object value) {
    response.setEvent(name, value);
  }

  public void setEvents(Map events) {
    response.setEvents(events);
  }

  public void setPortletMode(PortletMode portletMode)
          throws PortletModeException {
    response.setPortletMode(portletMode);
  }

  public void setRenderParameter(String key, String value) {
    response.setRenderParameter(key, value);
  }

  public void setRenderParameter(String key, String[] values) {
    response.setRenderParameter(key, values);
  }

  public void setRenderParameters(Map parameters) {
    response.setRenderParameters(parameters);
  }

  public void setWindowState(WindowState windowState)
          throws WindowStateException {
    response.setWindowState(windowState);
  }

  public void addProperty(String key, String value) {
    response.addProperty(key, value);
  }

  public PortletURL createActionURL() {
    return response.createActionURL();
  }

  public PortletURL createRenderURL() {
    return response.createRenderURL();
  }

  public ResourceURL createResourceURL() {
    return response.createResourceURL();
  }

  public String encodeURL(String path) {
    return response.encodeURL(path);
  }

  public String getNamespace() {
    return response.getNamespace();
  }

  public void setProperty(String key, String value) {
    response.setProperty(key, value);
  }

  public ActionResponse getResponse() {
    return response;
  }

  public void setResponse(ActionResponse response) {
    this.response = response;
  }

  public PortletMode getPortletMode() {
    return response.getPortletMode();
  }

  public Map getRenderParameterMap() {
    return response.getRenderParameterMap();
  }

  public WindowState getWindowState() {
    return response.getWindowState();
  }

  public void addProperty(Cookie cookie) {
    response.addProperty(cookie);
}

}
