package javax.portlet.filter;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.Enumeration;
import java.util.Locale;
import java.util.Map;

import javax.portlet.PortalContext;
import javax.portlet.PortletMode;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletSession;
import javax.portlet.RenderRequest;
import javax.portlet.WindowState;
import javax.servlet.http.Cookie;

public class RenderRequestWrapper implements RenderRequest {

  RenderRequest request;

  private RenderRequestWrapper() {
  }

  public RenderRequestWrapper(RenderRequest request) {
    this.request = request;
  }

  public Object getAttribute(String name) {
    return request.getAttribute(name);
  }

  public Enumeration getAttributeNames() {
    return request.getAttributeNames();
  }

  public String getAuthType() {
    return request.getAuthType();
  }

  public String getContextPath() {
    return request.getContextPath();
  }

  public Locale getLocale() {
    return request.getLocale();
  }

  public Enumeration getLocales() {
    return request.getLocales();
  }

  public String getParameter(String name) {
    return request.getParameter(name);
  }

  public Map getParameterMap() {
    return request.getParameterMap();
  }

  public Enumeration getParameterNames() {
    return request.getParameterNames();
  }

  public String[] getParameterValues(String name) {
    return request.getParameterValues(name);
  }

  public PortalContext getPortalContext() {
    return request.getPortalContext();
  }

  public PortletMode getPortletMode() {
    return request.getPortletMode();
  }

  public PortletSession getPortletSession() {
    return request.getPortletSession();
  }

  public PortletSession getPortletSession(boolean create) {
    return request.getPortletSession(create);
  }

  public PortletPreferences getPreferences() {
    return request.getPreferences();
  }

  public Enumeration getProperties(String name) {
    return request.getProperties(name);
  }

  public String getProperty(String name) {
    return request.getProperty(name);
  }

  public Enumeration getPropertyNames() {
    return request.getPropertyNames();
  }

  public String getRemoteUser() {
    return request.getRemoteUser();
  }

  public String getRequestedSessionId() {
    return request.getRequestedSessionId();
  }

  public String getResponseContentType() {
    return request.getResponseContentType();
  }

  public Enumeration getResponseContentTypes() {
    return request.getResponseContentTypes();
  }

  public String getScheme() {
    return request.getScheme();
  }

  public String getServerName() {
    return request.getServerName();
  }

  public int getServerPort() {
    return request.getServerPort();
  }

  public Principal getUserPrincipal() {
    return request.getUserPrincipal();
  }

  public String getWindowId() {
    return request.getWindowId();
  }

  public WindowState getWindowState() {
    return request.getWindowState();
  }

  public boolean isPortletModeAllowed(PortletMode mode) {
    return request.isPortletModeAllowed(mode);
  }

  public boolean isRequestedSessionIdValid() {
    return request.isRequestedSessionIdValid();
  }

  public boolean isSecure() {
    return request.isSecure();
  }

  public boolean isUserInRole(String role) {
    return request.isUserInRole(role);
  }

  public boolean isWindowStateAllowed(WindowState state) {
    return request.isWindowStateAllowed(state);
  }

  public void removeAttribute(String name) {
    request.removeAttribute(name);
  }

  public void setAttribute(String name, Object o) {
    request.setAttribute(name, o);
  }

  public RenderRequest getRequest() {
    return request;
  }

  public void setRequest(RenderRequest request) {
    this.request = request;
  }

  public String getETag() {
    return request.getETag();
  }

  public Cookie[] getCookies() {
    return request.getCookies();
  }

}
