package javax.portlet.filter;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Locale;

import javax.portlet.CacheControl;
import javax.portlet.PortletURL;
import javax.portlet.ResourceResponse;
import javax.portlet.ResourceURL;
import javax.servlet.http.Cookie;


public class ResourceResponseWrapper implements ResourceResponse {

  ResourceResponse response;

  private ResourceResponseWrapper() {
  }

  public ResourceResponseWrapper(ResourceResponse response) {
    this.response = response;
  }

  public void addProperty(String key, String value) {
    response.addProperty(key, value);
  }

  public PortletURL createActionURL() {
    return response.createActionURL();
  }

  public PortletURL createRenderURL() {
    return response.createRenderURL();
  }

  public ResourceURL createResourceURL() {
    return response.createResourceURL();
  }
  
  public String encodeURL(String path) {
    return response.encodeURL(path);
  }

  public String getNamespace() {
    return response.getNamespace();
  }

  public void setProperty(String key, String value) {
    response.setProperty(key, value);
  }

  public void flushBuffer() throws IOException {
    response.flushBuffer();
  }

  public int getBufferSize() {
    return response.getBufferSize();
  }

  public String getCharacterEncoding() {
    return response.getCharacterEncoding();
  }

  public String getContentType() {
    return response.getContentType();
  }

  public Locale getLocale() {
    return response.getLocale();
  }

  public OutputStream getPortletOutputStream() throws IOException {
    return response.getPortletOutputStream();
  }

  public PrintWriter getWriter() throws IOException {
    return response.getWriter();
  }

  public boolean isCommitted() {
    return response.isCommitted();
  }

  public void reset() {
    response.reset();
  }

  public void resetBuffer() {
    response.resetBuffer();
  }

  public void setBufferSize(int size) {
    response.setBufferSize(size);
  }

  public void setContentType(String type) {
    response.setContentType(type);
  }

  public CacheControl getCacheControl() {
    return response.getCacheControl();
  }

  public void setCharacterEncoding(String charset) {
    this.setCharacterEncoding(charset);
    return;
  }

  public void setLocale(Locale loc) {
    this.setLocale(loc);
    return;
  }

  public void addProperty(Cookie cookie) {
    response.addProperty(cookie);
  }

  public void setContentLength(int len) {
    response.setContentLength(len);
  }  

}
